## shadowsocks-libev 3.0.5+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

set(PROJECT_NAME shadowsocks-libev)
set(RELEASE_DATE 2017-3-21)
set(PROJECT_VERSION "3.0.5")
set(PROJECT_DESC "a lightweight secured socks5 proxy")
set(PROJECT_URL "https://shadowsocks.org")
set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")
project(${PROJECT_NAME})

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")

#set(CMAKE_BINARY_DIR ${CMAKE_SOURCE_DIR}/out)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)
set(CMAKE_MACOSX_RPATH TRUE)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug)
endif ()
# Detect linux
if (UNIX AND NOT APPLE)
    set(LINUX TRUE)
endif ()

message(STATUS "Running cmake version ${CMAKE_VERSION}")

# Will set GIT_EXECUTABLE and GIT_FOUND
# find_package(Git)

# Run platform tests
include(${CMAKE_SOURCE_DIR}/cmake/configure.cmake)
configure_file(${CMAKE_SOURCE_DIR}/cmake/config.h.cmake ${CMAKE_SOURCE_DIR}/src/config.h)
add_definitions(-DHAVE_CONFIG_H)

# pkg-config
configure_file(
        "${CMAKE_SOURCE_DIR}/cmake/shadowsocks-libev.pc.cmake"
        "${CMAKE_BINARY_DIR}/pkgconfig/shadowsocks-libev.pc"
        @ONLY
)
install(FILES
        "${CMAKE_BINARY_DIR}/pkgconfig/shadowsocks-libev.pc"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
        )

# We need libcork,libipset headers
include_directories(libcork/include)
include_directories(libipset/include)
include_directories(libbloom/murmur2)
include_directories(libbloom)

set(LIBCORK_SOURCE
        libcork/src/libcork/cli/commands.c
        libcork/src/libcork/core/allocator.c
        libcork/src/libcork/core/error.c
        libcork/src/libcork/core/gc.c
        libcork/src/libcork/core/hash.c
        libcork/src/libcork/core/ip-address.c
        libcork/src/libcork/core/mempool.c
        libcork/src/libcork/core/timestamp.c
        libcork/src/libcork/core/u128.c
        libcork/src/libcork/core/version.c
        libcork/src/libcork/ds/array.c
        libcork/src/libcork/ds/bitset.c
        libcork/src/libcork/ds/buffer.c
        libcork/src/libcork/ds/dllist.c
        libcork/src/libcork/ds/file-stream.c
        libcork/src/libcork/ds/hash-table.c
        libcork/src/libcork/ds/managed-buffer.c
        libcork/src/libcork/ds/ring-buffer.c
        libcork/src/libcork/ds/slice.c
        libcork/src/libcork/posix/directory-walker.c
        libcork/src/libcork/posix/env.c
        libcork/src/libcork/posix/exec.c
        libcork/src/libcork/posix/files.c
        libcork/src/libcork/posix/process.c
        libcork/src/libcork/posix/subprocess.c
        libcork/src/libcork/pthreads/thread.c
        )

add_library(cork STATIC ${LIBCORK_SOURCE})
target_compile_definitions(cork PUBLIC -DCORK_API=CORK_LOCAL)

add_library(cork-shared SHARED ${LIBCORK_SOURCE})
target_compile_definitions(cork-shared PUBLIC -DCORK_API=CORK_EXPORT)
set_target_properties(cork-shared PROPERTIES OUTPUT_NAME cork)

set(LIBIPSET_SOURCE
        libipset/src/libipset/general.c
        libipset/src/libipset/bdd/assignments.c
        libipset/src/libipset/bdd/basics.c
        libipset/src/libipset/bdd/bdd-iterator.c
        libipset/src/libipset/bdd/expanded.c
        libipset/src/libipset/bdd/reachable.c
        libipset/src/libipset/bdd/read.c
        libipset/src/libipset/bdd/write.c
        libipset/src/libipset/map/allocation.c
        libipset/src/libipset/map/inspection.c
        libipset/src/libipset/map/ipv4_map.c
        libipset/src/libipset/map/ipv6_map.c
        libipset/src/libipset/map/storage.c
        libipset/src/libipset/set/allocation.c
        libipset/src/libipset/set/inspection.c
        libipset/src/libipset/set/ipv4_set.c
        libipset/src/libipset/set/ipv6_set.c
        libipset/src/libipset/set/iterator.c
        libipset/src/libipset/set/storage.c
        )

add_library(ipset STATIC ${LIBIPSET_SOURCE})

add_library(ipset-shared SHARED ${LIBIPSET_SOURCE})
set_target_properties(ipset-shared PROPERTIES OUTPUT_NAME ipset)

set(LIBBLOOM_SOURCE
        libbloom/bloom.c
        libbloom/murmur2/MurmurHash2.c
        )

add_library(bloom STATIC ${LIBBLOOM_SOURCE})
target_link_libraries(ipset cork bloom)

add_library(bloom-shared SHARED ${LIBBLOOM_SOURCE})
target_link_libraries(ipset-shared cork-shared bloom-shared)
set_target_properties(bloom-shared PROPERTIES OUTPUT_NAME bloom)

add_subdirectory(src)

=== src/CMakeLists.txt ===
# redir need linux/* stuff
if (LINUX)
    option(WITH_SS_REDIR "Build ss-redir" ON)
else ()
    option(WITH_SS_REDIR "Build ss-redir" OFF)
endif ()


set(SS_SNI_SOURCE
        http.c
        tls.c
        rule.c
        )

set(SS_CRYPTO_SOURCE
        crypto.c
        aead.c
        stream.c
        base64.c
        )

set(SS_PLUGIN_SOURCE
        plugin.c
        )

set(SS_SHARED_SOURCES
        ppbloom.c
        utils.c
        jconf.c
        json.c
        netutils.c
        )

set(LIBSHADOWSOCKS_LIBEV_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        acl.c
        local.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        ${SS_SNI_SOURCE})

set(SS_LOCAL_SOURCE
        ${LIBSHADOWSOCKS_LIBEV_SOURCE}

        )

set(SS_TUNNEL_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        tunnel.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        )

set(SS_SERVER_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        acl.c
        resolv.c
        server.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        ${SS_SNI_SOURCE}
        )

set(SS_MANAGER_SOURCE
        ${SS_SHARED_SOURCES}
        manager.c
        )

set(SS_REDIR_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        redir.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        ${SS_SNI_SOURCE}
        )


find_library(LIBSODIUM libsodium.a)
find_library(LIBMBEDTLS libmbedtls.a)
find_library(LIBMBEDCRYPTO libmbedcrypto.a)
find_library(LIBEV libev.a)
find_library(LIBUDNS libudns.a)
find_library(LIBPCRE libpcre.a)

find_library(LIBSODIUM_SHARED sodium)
find_library(LIBMBEDTLS_SHARED mbedtls)
find_library(LIBMBEDCRYPTO_SHARED mbedcrypto)
find_library(LIBEV_SHARED ev)
find_library(LIBUDNS_SHARED udns)
find_library(LIBPCRE_SHARED pcre)

list(APPEND DEPS bloom m ${LIBEV} ${LIBUDNS} ${LIBPCRE} ${LIBSODIUM} ${LIBMBEDTLS} ${LIBMBEDCRYPTO})
list(APPEND DEPS_SHARED bloom-shared m ${LIBEV_SHARED} ${LIBUDNS_SHARED} ${LIBPCRE_SHARED} ${LIBSODIUM_SHARED}
${LIBMBEDTLS_SHARED} ${LIBMBEDCRYPTO_SHARED})

find_package (Threads)

# Add our targets
add_executable(ss-server ${SS_SERVER_SOURCE})
add_executable(ss-tunnel ${SS_TUNNEL_SOURCE})
add_executable(ss-manager ${SS_MANAGER_SOURCE})
add_executable(ss-local ${SS_LOCAL_SOURCE})
if (WITH_SS_REDIR)
    add_executable(ss-redir ${SS_REDIR_SOURCE})
else ()
    add_executable(ss-redir EXCLUDE_FROM_ALL ${SS_REDIR_SOURCE})
endif ()
add_library(shadowsocks-libev STATIC ${LIBSHADOWSOCKS_LIBEV_SOURCE})


target_compile_definitions(ss-server PUBLIC -DMODULE_REMOTE)
target_compile_definitions(ss-tunnel PUBLIC -DMODULE_TUNNEL)
target_compile_definitions(ss-manager PUBLIC -DMODULE_MANAGER)
target_compile_definitions(ss-local PUBLIC -DMODULE_LOCAL)
target_compile_definitions(ss-redir PUBLIC -DMODULE_REDIR)
target_compile_definitions(shadowsocks-libev PUBLIC -DMODULE_LOCAL)

target_link_libraries(ss-server cork ipset ${DEPS})
target_link_libraries(ss-tunnel cork ${DEPS})
target_link_libraries(ss-manager m bloom cork ${LIBEV} ${LIBUDNS})
target_link_libraries(ss-local cork ipset ${DEPS})
target_link_libraries(ss-redir cork ipset ${DEPS})
target_link_libraries(shadowsocks-libev cork ipset ${DEPS})

# ------------------------------------------------------------------
# Shared
add_executable(ss-server-shared ${SS_SERVER_SOURCE})
add_executable(ss-tunnel-shared ${SS_TUNNEL_SOURCE})
add_executable(ss-manager-shared ${SS_MANAGER_SOURCE})
add_executable(ss-local-shared ${SS_LOCAL_SOURCE})
if (WITH_SS_REDIR)
    add_executable(ss-redir-shared ${SS_REDIR_SOURCE})
else ()
    add_executable(ss-redir-shared EXCLUDE_FROM_ALL ${SS_REDIR_SOURCE})
endif ()
add_library(shadowsocks-libev-shared SHARED ${LIBSHADOWSOCKS_LIBEV_SOURCE})

target_compile_definitions(ss-server-shared PUBLIC -DMODULE_REMOTE)
target_compile_definitions(ss-tunnel-shared PUBLIC -DMODULE_TUNNEL)
target_compile_definitions(ss-manager-shared PUBLIC -DMODULE_MANAGER)
target_compile_definitions(ss-local-shared PUBLIC -DMODULE_LOCAL)
target_compile_definitions(ss-redir-shared PUBLIC -DMODULE_REDIR)
target_compile_definitions(shadowsocks-libev-shared PUBLIC -DMODULE_LOCAL)

target_link_libraries(ss-server-shared cork-shared ipset-shared ${DEPS_SHARED})
target_link_libraries(ss-tunnel-shared cork-shared ${DEPS_SHARED})
target_link_libraries(ss-manager-shared m bloom-shared cork-shared ${CMAKE_THREAD_LIBS_INIT} ${LIBEV_SHARED} ${LIBUDNS_SHARED})
target_link_libraries(ss-local-shared cork-shared ipset-shared ${DEPS_SHARED})
target_link_libraries(ss-redir-shared cork-shared ipset-shared ${DEPS_SHARED})
target_link_libraries(shadowsocks-libev-shared cork-shared ipset-shared ${DEPS_SHARED})

set_target_properties(ss-server-shared PROPERTIES OUTPUT_NAME ss-server)
set_target_properties(ss-tunnel-shared PROPERTIES OUTPUT_NAME ss-tunnel)
set_target_properties(ss-manager-shared PROPERTIES OUTPUT_NAME ss-manager)
set_target_properties(ss-local-shared PROPERTIES OUTPUT_NAME ss-local)
set_target_properties(ss-redir-shared PROPERTIES OUTPUT_NAME ss-redir)

set_target_properties(ss-server-shared ss-tunnel-shared ss-manager-shared ss-local-shared ss-redir-shared
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/shared/bin"
        )

set_target_properties(shadowsocks-libev-shared PROPERTIES OUTPUT_NAME shadowsocks-libev)
target_compile_definitions(shadowsocks-libev-shared PUBLIC -DMODULE_LOCAL)
target_link_libraries(shadowsocks-libev-shared cork-shared ipset-shared ${DEPS_SHARED})


install(DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        DESTINATION bin
        FILES_MATCHING PATTERN "ss-*")


add_custom_target(distclean
        COMMAND ${CMAKE_COMMAND} -E echo WARNING: distclean target is not functional
        COMMAND ${CMAKE_COMMAND} -E echo Use 'git clean -fdx' instead
        VERBATIM
        )

## shadowsocks-libev 2.4.7+20160630+ds

=== debian/changelog ===
shadowsocks-libev (2.4.7+20160630+ds-3) unstable; urgency=low

  * debian/rules:
    - Add param "--disable-ssp" to dh_auto_configure command.
      Thanks to Aaron M. Ucko and Boyuan Yang. (Closes: #829498)
  * debian/patches:
    - Add 0003 patch, to fix PATH_MAX for GNU/Hurd.
    - Cherry-Pick two patch from upstream as 0004 and 0005

 -- Roger Shimizu <rogershimizu@gmail.com>  Mon, 18 Jul 2016 23:26:20 +0900

shadowsocks-libev (2.4.7+20160630+ds-2) unstable; urgency=medium

  * debian/control
    - Move to git repo to collab-maint on alioth
  * Change way to handle config file
    Install config.json file to /usr/share/<pkg>, instead of /etc, and then
    generate a config file under /etc, because conffile (under /etc) cannot
    be modified by maintainer script according to Debian Policy.
    Thanks help from Andreas Beckmann. (Closes: #829478)

 -- Roger Shimizu <rogershimizu@gmail.com>  Wed, 06 Jul 2016 01:49:40 +0200

shadowsocks-libev (2.4.7+20160630+ds-1) unstable; urgency=medium

  * Initial release (Closes: #824268)

 -- Roger Shimizu <rogershimizu@gmail.com>  Sat, 02 Jul 2016 10:18:59 +0200

=== debian/control ===
Source: shadowsocks-libev
Section: net
Priority: extra
Maintainer: Roger Shimizu <rogershimizu@gmail.com>
Uploaders: Max Lv <max.c.lv@gmail.com>, Boyuan Yang <073plan@gmail.com>
Build-Depends: debhelper (>=9.20160403), dh-systemd, pkg-config, libmbedtls-dev, libev-dev, libudns-dev, libsodium-dev, libcork-dev, libcorkipset-dev
Standards-Version: 3.9.8
Homepage: https://www.shadowsocks.org
Vcs-Git: https://anonscm.debian.org/git/collab-maint/shadowsocks-libev.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/shadowsocks-libev.git

Package: shadowsocks-libev
Replaces: shadowsocks (<< 1.5.3-2)
Breaks: shadowsocks (<< 1.5.3-2)
Architecture: any
Depends: apg, ${shlibs:Depends}, ${misc:Depends}
Description: lightweight and secure socks5 proxy
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries. OpenSSL dependency is removed due to license issue.

Package: libshadowsocks-libev1
Architecture: any
Multi-Arch: same
Section: libs
Breaks: shadowsocks-libev (<< 2.4.0)
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lightweight and secure socks5 proxy (shared library)
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries. OpenSSL dependency is removed due to license issue.
 .
 This package provides shared libraries.

Package: libshadowsocks-libev-dev
Architecture: any
Section: libdevel
Breaks: shadowsocks-libev (<< 2.4.0)
Depends: libshadowsocks-libev1 (= ${binary:Version}), ${misc:Depends}
Description: lightweight and secure socks5 proxy (development files)
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries. OpenSSL dependency is removed due to license issue.
 .
 This package provides C header files for the libraries.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# Security Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_install:
	find src/ -name '*.la' -delete
	dh_auto_install

override_dh_auto_configure:
	dh_auto_configure -- --disable-ssp \
		--with-crypto-library=mbedtls \
        --enable-shared --enable-system-shared-lib

%:
	dh $@ --with systemd

## shadowsocks-libev 2.4.8+ds

=== debian/changelog ===
shadowsocks-libev (2.4.8+ds-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * debian/patches:
    - Add patch to disable cipher CHACHA20IETF, which it's not supported
      by libsodium in jessie

 -- Roger Shimizu <rogershimizu@gmail.com>  Wed, 05 Oct 2016 02:51:35 +0900

shadowsocks-libev (2.4.8+ds-1) unstable; urgency=medium

  * Update to upstream v2.4.8
    - Remove patches merged by upstream: 0003 0004 0005
    - Update patch 0001: make it appliable to this version
    - Update debian/control to add newly appended build-dep
    - Update debian/rulesi to adjust param ordering as close as upstream
    - Update debian/copyright to remove man/, which merged into doc/ folder
  * debian/patches:
    - Cherry-Pick upstream patch 0003: add a few spaces to asciidoc to make
      lintian happy. Thanks to Max Lv for fixing this.

 -- Roger Shimizu <rogershimizu@gmail.com>  Fri, 22 Jul 2016 23:10:14 +0900

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,9 @@
 Priority: extra
 Maintainer: Roger Shimizu <rogershimizu@gmail.com>
 Uploaders: Max Lv <max.c.lv@gmail.com>, Boyuan Yang <073plan@gmail.com>
-Build-Depends: debhelper (>=9.20160403), dh-systemd, pkg-config, libmbedtls-dev, libev-dev, libudns-dev, libsodium-dev, libcork-dev, libcorkipset-dev
+Build-Depends: debhelper (>=9.20160403~), dh-systemd, pkg-config, asciidoc,
+               xmlto, libmbedtls-dev, libev-dev, libudns-dev, libsodium-dev,
+               libcork-dev, libcorkipset-dev
 Standards-Version: 3.9.8
 Homepage: https://www.shadowsocks.org
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/shadowsocks-libev.git

## shadowsocks-libev 2.5.5+ds

=== debian/changelog ===
shadowsocks-libev (2.5.5+ds-2) unstable; urgency=medium

  * debian/copyright:
    - update slightly
  * debian/control:
    - Add lsb-base as dependency to package shadowsocks-libev, since the init
      script sources /lib/lsb/init-functions utility functions
    - Change the order of binary packages.
      Because README.Debian by default only installs on 1st binary package.
      (Closes: #842039)
    - Bump libcork-dev dependency version to incorporate the new libcork16
      library transition to avoid possible build issue.
  * debian/patches:
    - Refresh patches
    - Backport a few fixes from upstream

 -- Roger Shimizu <rogershimizu@gmail.com>  Sun, 30 Oct 2016 12:24:15 +0900

shadowsocks-libev (2.5.5+ds-1) unstable; urgency=medium

  * Update to upstream v2.5.5

 -- Roger Shimizu <rogershimizu@gmail.com>  Thu, 13 Oct 2016 00:57:07 +0900

shadowsocks-libev (2.5.3+ds-1) experimental; urgency=low

  * Update to upstream v2.5.3
    - Remove patches merged by upstream: 0003
    - Update patch 0001 0002: make it appliable to this version
    - Update debian/copyright: remove .github/, add newly appended files
  * debian/control:
    - Update based on upstream's change
    - Add Replaces and Breaks for lib version up
  * debian/maint-tools/:
    - Add two script to make life easier for new upstream release
  * debian/copyright:
    - Add license information for m4/ files

 -- Roger Shimizu <rogershimizu@gmail.com>  Tue, 04 Oct 2016 23:05:55 +0900

## shadowsocks-libev 2.5.6+ds

=== debian/changelog ===
shadowsocks-libev (2.5.6+ds-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * debian/patches:
    - Update 0003 patch, to disable cipher CHACHA20IETF,
      which it's not supported by libsodium in jessie
    - Refresh patches

 -- Roger Shimizu <rogershimizu@gmail.com>  Mon, 28 Nov 2016 01:18:44 +0900

shadowsocks-libev (2.5.6+ds-1) unstable; urgency=medium

  * New upstream release 2.5.6
  * debian/maint-tools:
    - Remove backported patches when merge with upstream
    - Fix typo and catch exception of tag existence
    - Add README

 -- Roger Shimizu <rogershimizu@gmail.com>  Sat, 05 Nov 2016 17:50:04 +0900

=== debian/control ===
Source: shadowsocks-libev
Section: net
Priority: extra
Maintainer: Roger Shimizu <rogershimizu@gmail.com>
Uploaders: Max Lv <max.c.lv@gmail.com>, Boyuan Yang <073plan@gmail.com>
Build-Depends:
 asciidoc,
 debhelper (>= 10),
 dh-systemd,
 libcork-dev (>= 0.15.0+ds-8),
 libcorkipset-dev,
 libev-dev,
 libmbedtls-dev,
 libpcre3-dev,
 libsodium-dev,
 libudns-dev,
 pkg-config,
 xmlto
Standards-Version: 3.9.8
Homepage: https://www.shadowsocks.org
Vcs-Git: https://anonscm.debian.org/git/collab-maint/shadowsocks-libev.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/shadowsocks-libev.git

Package: shadowsocks-libev
Replaces: shadowsocks (<< 1.5.3-2)
Breaks: shadowsocks (<< 1.5.3-2)
Architecture: any
Depends:
 apg,
 lsb-base (>= 3.0-6),
 ${misc:Depends},
 ${shlibs:Depends}
Description: lightweight and secure socks5 proxy
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries. OpenSSL dependency is removed due to license issue.

Package: libshadowsocks-libev-dev
Architecture: any
Section: libdevel
Breaks: shadowsocks-libev (<< 2.4.0)
Depends:
 libshadowsocks-libev2 (= ${binary:Version}),
 ${misc:Depends}
Description: lightweight and secure socks5 proxy (development files)
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries. OpenSSL dependency is removed due to license issue.
 .
 This package provides C header files for the libraries.

Package: libshadowsocks-libev2
Architecture: any
Multi-Arch: same
Section: libs
Replaces: libshadowsocks-libev1
Breaks:
 libshadowsocks-libev1,
 shadowsocks-libev (<< 2.4.0)
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: lightweight and secure socks5 proxy (shared library)
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries. OpenSSL dependency is removed due to license issue.
 .
 This package provides shared libraries.

## shadowsocks-libev 2.6.0+ds

=== debian/changelog ===
shadowsocks-libev (2.6.0+ds-2) unstable; urgency=medium

  * Revert obfuscating function added since v2.6.0,
    due to it's already dropped by upstream, and won't be
    supported in the future.
  * debian/patches:
    - Add revert patch and refresh patches.
  * debian/copyright:
    - Add new entry of copyright on src/base64.{c,h}
    - Update copyright year.

 -- Roger Shimizu <rogershimizu@gmail.com>  Thu, 05 Jan 2017 23:55:09 +0900

shadowsocks-libev (2.6.0+ds-1) experimental; urgency=medium

  * New upstream release 2.6.0
  * debian/maint-tools:
    - Update README and script
  * debian/patches:
    - Rebase patches.
    - Backport a few patches from upstream.
  * debian/control & debian/shadowsocks-libev.postinst:
    - Add capabilities for Debian, so it's able to run ss-* as non-root.
      Cherry-picked from upstream git repo, And thanks to
      Zhengjun Zhang <siyanmao.sec@gmail.com>.
  * debian/control:
    - Build-Depends on asciidoc-base instead of asciidoc.
    - Set libshadowsocks-libev-dev as "Multi-Arch: same", based on wiki:
      https://wiki.debian.org/MultiArch/Hints

 -- Roger Shimizu <rogershimizu@gmail.com>  Thu, 05 Jan 2017 01:40:09 +0900

## shadowsocks-libev 2.6.1+ds

=== debian/changelog ===
shadowsocks-libev (2.6.1+ds-2) unstable; urgency=medium

  * debian/control:
    - Limit "Suggests: libcap2-bin" in "linux-any". Hurd/kFreeBSD
      don't have this supported.
  * debian/patches:
    - Backport a patch from upstream to fix FTBFS on GNU/Hurd.
    - Backport a few patches from upstream.

 -- Roger Shimizu <rogershimizu@gmail.com>  Tue, 10 Jan 2017 23:38:17 +0900

shadowsocks-libev (2.6.1+ds-1) unstable; urgency=medium

  * New upstream release 2.6.1
  * debian/copyright:
    - Remove entry of copyright on src/base64.{c,h}, because those two src
      files has been removed from upstream.
  * debian/patches:
    - Backport a few patches from upstream.

 -- Roger Shimizu <rogershimizu@gmail.com>  Tue, 10 Jan 2017 00:07:49 +0900

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Roger Shimizu <rogershimizu@gmail.com>
 Uploaders: Max Lv <max.c.lv@gmail.com>, Boyuan Yang <073plan@gmail.com>
 Build-Depends:
- asciidoc,
+ asciidoc-base,
  debhelper (>= 10),
  dh-systemd,
  libcork-dev (>= 0.15.0+ds-8),
@@ -30,6 +30,8 @@
  lsb-base (>= 3.0-6),
  ${misc:Depends},
  ${shlibs:Depends}
+Suggests:
+ libcap2-bin [linux-any]
 Description: lightweight and secure socks5 proxy
  Shadowsocks-libev is a lightweight and secure socks5 proxy for
  embedded devices and low end boxes.
@@ -40,6 +42,7 @@
 
 Package: libshadowsocks-libev-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Breaks: shadowsocks-libev (<< 2.4.0)
 Depends:

=== debian/rules ===
--- 
+++ 
@@ -14,9 +14,11 @@
 	dh_auto_install
 
 override_dh_auto_configure:
-	dh_auto_configure -- --disable-ssp \
-		--with-crypto-library=mbedtls \
-        --enable-shared --enable-system-shared-lib
+	dh_auto_configure -- \
+        --enable-shared \
+        --disable-ssp \
+        --enable-system-shared-lib \
+        --with-crypto-library=mbedtls
 
 %:
 	dh $@ --with systemd

## shadowsocks-libev 2.6.2+ds

=== debian/changelog ===
shadowsocks-libev (2.6.2+ds-1) unstable; urgency=medium

  * debian/shadowsocks-libev.{default,init,service}:
    - Run service as non-root.
  * debian/control:
    - Move libcap2-bin from Suggests to Depends.
  * debian/shadowsocks-libev.init:
    - To make plugin stop working also.
  * debian/patches:
    - Refresh existing patches.
    - Backport a few patches from upstream:
      + Fix typo of upstream changelog.
      + Fix src/server.c (Patch 0004)
      + Update manpage docs.
      + Update README of upstream.
      + Fix completions/bash/ss-server.
  * debian/copyright:
    - Update copyright year.
    - Remove a few files and directory from Files-Excluded, because those
      are already removed from upstream.

 -- Roger Shimizu <rogershimizu@gmail.com>  Sat, 21 Jan 2017 15:22:27 +0900

## shadowsocks-libev 2.6.3+ds

=== debian/changelog ===
shadowsocks-libev (2.6.3+ds-3+deb9u1) stretch-security; urgency=high

  * debian/patches:
    - Backport a few patches from upstream.
      + [c67d275] Fix potential local exploit issue.
        Thanks to X41 D-Sec GmbH, Niklas Abel, for the reporting:
          https://www.x41-dsec.de/lab/advisories/x41-2017-010-shadowsocks-libev/

 -- Roger Shimizu <rogershimizu@gmail.com>  Wed, 25 Oct 2017 20:49:42 +0900

shadowsocks-libev (2.6.3+ds-3) unstable; urgency=medium

  * debian/patches:
    - Backport a few patches from upstream:
      + Fix Upstream BTS#1210 (again):
        Update doc (manpages) to fix typos. Thanks to Simon Shi.
      + Update ACL list, Upstream BTS#1394.
      + Fix two potential out of bound access, Upstream BTS#1465.

 -- Roger Shimizu <rogershimizu@gmail.com>  Thu, 20 Apr 2017 22:44:32 +0900

shadowsocks-libev (2.6.3+ds-2) unstable; urgency=medium

  * debian/patches:
    - Backport a few patches from upstream:
      + Fix Upstream BTS#1148:
        ss-local doesn't do DNS resolving for acl bypassed domains.
        (Closes: #859499).
      + Fix Upstream BTS#1210:
        Update doc (manpages) to fix typos. Thanks to Simon Shi.
        (Closes: #859502).

 -- Roger Shimizu <rogershimizu@gmail.com>  Tue, 04 Apr 2017 21:48:26 +0900

shadowsocks-libev (2.6.3+ds-1) unstable; urgency=medium

  * New upstream release 2.6.3
  * debian/copyright: Add .gitmodules and m4/lib-link.m4 to
    Files-Excluded list.
  * debian/patches:
    - Rebase previous patches, because upstream modified autoconf
      files heavily.
  * debian/rules:
    - Remove --enable-system-shared-lib from configure param.
    - Add note for --disable-ssp.
  * debian/patches:
    - Backport a few patches from upstream:
      + Cleanup unused _WIN32 #ifdef.
      + Add condition to check whether to support chacha20-ietf cipher
        (Patch 0004~0006 0008).
      + Cleanup configure.ac.

 -- Roger Shimizu <rogershimizu@gmail.com>  Wed, 25 Jan 2017 19:58:24 +0900

=== debian/control ===
--- 
+++ 
@@ -27,11 +27,10 @@
 Architecture: any
 Depends:
  apg,
+ libcap2-bin [linux-any],
  lsb-base (>= 3.0-6),
  ${misc:Depends},
  ${shlibs:Depends}
-Suggests:
- libcap2-bin [linux-any]
 Description: lightweight and secure socks5 proxy
  Shadowsocks-libev is a lightweight and secure socks5 proxy for
  embedded devices and low end boxes.

=== debian/rules ===
--- 
+++ 
@@ -17,8 +17,9 @@
 	dh_auto_configure -- \
         --enable-shared \
         --disable-ssp \
-        --enable-system-shared-lib \
         --with-crypto-library=mbedtls
+	# Whether to have stack-protector is decided by dpkg-buildflags.
+	# So --disable-ssp here should be safe. See Bug#829498
 
 %:
 	dh $@ --with systemd

=== debian/watch ===
version=4

opts="repack,compression=xz, \
   dversionmangle=s/\+ds\d*$//,repacksuffix=+ds, \
   filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%shadowsocks-libev-$1.tar.gz%" \
   https://github.com/shadowsocks/shadowsocks-libev/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## shadowsocks-libev 3.0.5+ds

=== debian/changelog ===
shadowsocks-libev (3.0.5+ds-1~exp1) experimental; urgency=medium

  * New upstream release 3.0.5
  * debian/control:
    - Add libbloom-dev as Build-Depends, which is required since 3.0.3.
  * debian/copyright:
    - Add new entry of scripts/build_deb.sh
  * debian/rules:
    - Remove old hardening environment variables which is not necessary
      any more.
    - Create libbloom folder temporarily for dh_autoreconf, because
      configure.ac complains without it.
  * debian/patches:
    - Backport patches from upstream, till commit [adbc0be].

 -- Roger Shimizu <rogershimizu@gmail.com>  Thu, 13 Apr 2017 21:24:48 +0900

shadowsocks-libev (3.0.2+ds-1~exp2) experimental; urgency=medium

  * debian/ folder sync with upstream:
    - README.Debian
      + Remove "Alternated crypto library" part, since upstream now
        supports mbedtls only.
    - config.json
      + Set rc4-md5 as default cipher
    - control
      + Add libsodium-dev version requirement >= 1.0.8~
      + Remove "OpenSSL dependency is removed due to license issue".
    - rules
      + Remove "--with systemd" because it's enabled by default since
        debhelper 10
    - shadowsocks-libev.docs
      + Add AUTHORS and README.md
  * debian/patches:
    - Backport a few patches from upstream.

 -- Roger Shimizu <rogershimizu@gmail.com>  Sat, 18 Feb 2017 16:36:44 +0900

shadowsocks-libev (3.0.2+ds-1~exp1) experimental; urgency=medium

  * New upstream release 3.0.2
  * debian/copyright:
    - Remove non-existing files from Files-Excluded list.
    - Add entry of src/base64.{c,h} and scripts/deb4*.sh.
  * debian/patches:
    - Remove all debian specific patches (0001 & 0002), after backporting
      a new autotool related patch from upstream. Thanks to Max Lv.
    - Backport a few patches from upstream.
  * debian/control:
    - Add asciidoc as alternative Build-Depends. Although sbuild doesn't
      support it, it's better to mention here, because there's no
      asciidoc-base package in jessie-backports and ubuntu.
    - Remove dh-systemd from Build-Depends, which is unnecessary in
      debhelper 10.
  * debian/shadowsocks-libev.postinst:
    - Add CAP_NET_ADMIN capability to ss-redir
  * debian/rules:
    - override_dh_autoreconf:
      + Since now we use autotool scripts the same as upstream, here we
        have to add some dummy folders/files to feed configure.ac.
    - override_dh_auto_configure:
      + Add --enable-system-shared-lib
      + Remove --with-crypto-library, since upstream now only supports
        mbedtls and removes this option.
  * debian/shadowsocks-libev.docs:
    - Install contrib scripts as docs.

 -- Roger Shimizu <rogershimizu@gmail.com>  Thu, 16 Feb 2017 02:35:57 +0900

=== debian/control ===
--- 
+++ 
@@ -4,15 +4,15 @@
 Maintainer: Roger Shimizu <rogershimizu@gmail.com>
 Uploaders: Max Lv <max.c.lv@gmail.com>, Boyuan Yang <073plan@gmail.com>
 Build-Depends:
- asciidoc-base,
+ asciidoc-base | asciidoc,
  debhelper (>= 10),
- dh-systemd,
+ libbloom-dev,
  libcork-dev (>= 0.15.0+ds-8),
  libcorkipset-dev,
  libev-dev,
  libmbedtls-dev,
  libpcre3-dev,
- libsodium-dev,
+ libsodium-dev (>= 1.0.8~),
  libudns-dev,
  pkg-config,
  xmlto
@@ -26,7 +26,7 @@
 Breaks: shadowsocks (<< 1.5.3-2)
 Architecture: any
 Depends:
- apg,
+ apg | pwgen,
  libcap2-bin [linux-any],
  lsb-base (>= 3.0-6),
  ${misc:Depends},
@@ -37,7 +37,7 @@
  .
  Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
  in pure C and only depends on libev, mbedTLS and a few other tiny
- libraries. OpenSSL dependency is removed due to license issue.
+ libraries.
 
 Package: libshadowsocks-libev-dev
 Architecture: any
@@ -53,7 +53,7 @@
  .
  Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
  in pure C and only depends on libev, mbedTLS and a few other tiny
- libraries. OpenSSL dependency is removed due to license issue.
+ libraries.
  .
  This package provides C header files for the libraries.
 
@@ -75,6 +75,6 @@
  .
  Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
  in pure C and only depends on libev, mbedTLS and a few other tiny
- libraries. OpenSSL dependency is removed due to license issue.
+ libraries.
  .
  This package provides shared libraries.

## shadowsocks-libev 3.0.6+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2017-3-21)
-set(PROJECT_VERSION "3.0.5")
+set(RELEASE_DATE 2017-4-26)
+set(PROJECT_VERSION "3.0.6")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")
@@ -15,6 +15,8 @@
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)
+set(RUNTIME_SHARED_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/shared/bin)
+
 set(CMAKE_MACOSX_RPATH TRUE)
 
 if (NOT CMAKE_BUILD_TYPE)
@@ -27,6 +29,8 @@
 
 message(STATUS "Running cmake version ${CMAKE_VERSION}")
 
+option(WITH_STATIC "build with static libraries." ON)
+
 # Will set GIT_EXECUTABLE and GIT_FOUND
 # find_package(Git)
 
@@ -37,13 +41,13 @@
 
 # pkg-config
 configure_file(
-        "${CMAKE_SOURCE_DIR}/cmake/shadowsocks-libev.pc.cmake"
-        "${CMAKE_BINARY_DIR}/pkgconfig/shadowsocks-libev.pc"
+        ${CMAKE_SOURCE_DIR}/cmake/shadowsocks-libev.pc.cmake
+        ${CMAKE_BINARY_DIR}/pkgconfig/shadowsocks-libev.pc
         @ONLY
 )
 install(FILES
-        "${CMAKE_BINARY_DIR}/pkgconfig/shadowsocks-libev.pc"
-        DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
+        ${CMAKE_BINARY_DIR}/pkgconfig/shadowsocks-libev.pc
+        DESTINATION pkgconfig
         )
 
 # We need libcork,libipset headers
@@ -81,8 +85,10 @@
         libcork/src/libcork/pthreads/thread.c
         )
 
+if (WITH_STATIC)
 add_library(cork STATIC ${LIBCORK_SOURCE})
 target_compile_definitions(cork PUBLIC -DCORK_API=CORK_LOCAL)
+endif ()
 
 add_library(cork-shared SHARED ${LIBCORK_SOURCE})
 target_compile_definitions(cork-shared PUBLIC -DCORK_API=CORK_EXPORT)
@@ -110,7 +116,9 @@
         libipset/src/libipset/set/storage.c
         )
 
+if (WITH_STATIC)
 add_library(ipset STATIC ${LIBIPSET_SOURCE})
+endif ()
 
 add_library(ipset-shared SHARED ${LIBIPSET_SOURCE})
 set_target_properties(ipset-shared PROPERTIES OUTPUT_NAME ipset)
@@ -120,12 +128,15 @@
         libbloom/murmur2/MurmurHash2.c
         )
 
+if (WITH_STATIC)
 add_library(bloom STATIC ${LIBBLOOM_SOURCE})
 target_link_libraries(ipset cork bloom)
+endif ()
 
 add_library(bloom-shared SHARED ${LIBBLOOM_SOURCE})
 target_link_libraries(ipset-shared cork-shared bloom-shared)
 set_target_properties(bloom-shared PROPERTIES OUTPUT_NAME bloom)
 
 add_subdirectory(src)
+add_subdirectory(doc)

=== debian/changelog ===
shadowsocks-libev (3.0.6+ds-1~exp1) experimental; urgency=medium

  [ Boyuan Yang ]
  * New upstream release 3.0.6
  * debian/patches:
    - drop all old backports patches.
    - cherry-pick upstream fixes till commit 3f0d39ae.
  * debian/copyright: refresh release date.

 -- Boyuan Yang <073plan@gmail.com>  Wed, 03 May 2017 16:54:51 +0800

## shadowsocks-libev 3.0.7+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2017-4-26)
-set(PROJECT_VERSION "3.0.6")
+set(RELEASE_DATE 2017-6-27)
+set(PROJECT_VERSION "3.0.7")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")

=== debian/changelog ===
shadowsocks-libev (3.0.7+ds-2) unstable; urgency=medium

  * Add back debian/patches/backport/README
  * debian/control:
    - Add to Suggests: haveged, kcptun, simple-obfs.
  * debian/patches:
    - Cherry-pick upstream fixes till commit 0e74ea50.
    - Add a patch to fix reproducible build.
  * Add debian/doc-base.

 -- Roger Shimizu <rogershimizu@gmail.com>  Mon, 10 Jul 2017 01:08:16 +0900

shadowsocks-libev (3.0.7+ds-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rogershimizu@gmail.com>  Tue, 04 Jul 2017 23:43:55 +0900

shadowsocks-libev (3.0.7+ds-1) unstable; urgency=medium

  * New upstream release 3.0.7
  * debian/control:
    Bump Standards-Version to 4.0.0, no changes required.
  * debian/patches:
    - drop all backported patches.

 -- Boyuan Yang <073plan@gmail.com>  Tue, 27 Jun 2017 15:34:23 +0800

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  libudns-dev,
  pkg-config,
  xmlto
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: https://www.shadowsocks.org
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/shadowsocks-libev.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/shadowsocks-libev.git
@@ -31,6 +31,10 @@
  lsb-base (>= 3.0-6),
  ${misc:Depends},
  ${shlibs:Depends}
+Suggests:
+ haveged,
+ kcptun,
+ simple-obfs
 Description: lightweight and secure socks5 proxy
  Shadowsocks-libev is a lightweight and secure socks5 proxy for
  embedded devices and low end boxes.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# Security Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Dummy folder for autotools scripts
LIBDIR=libbloom libcork libipset

override_dh_auto_install:
	find src/ -name '*.la' -delete
	dh_auto_install

override_dh_autoreconf:
	# autoreconf script conplains without the two folders
	for libdir in ${LIBDIR}; do \
		mkdir -p $$libdir; \
		touch $$libdir/Makefile.in; \
	done
	dh_autoreconf
	rm -rf ${LIBDIR}

override_dh_auto_configure:
	# Whether to have stack-protector is decided by dpkg-buildflags.
	# So --disable-ssp here should be safe. See Bug#829498
	dh_auto_configure -- \
		--enable-shared \
		--enable-system-shared-lib \
		--disable-ssp

%:
	dh $@

## shadowsocks-libev 3.0.8+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2017-6-27)
-set(PROJECT_VERSION "3.0.7")
+set(RELEASE_DATE 2017-7-27)
+set(PROJECT_VERSION "3.0.8")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -83,12 +83,14 @@
         )
 
 
+if (WITH_STATIC)
 find_library(LIBSODIUM libsodium.a)
 find_library(LIBMBEDTLS libmbedtls.a)
 find_library(LIBMBEDCRYPTO libmbedcrypto.a)
 find_library(LIBEV libev.a)
 find_library(LIBUDNS libudns.a)
 find_library(LIBPCRE libpcre.a)
+endif ()
 
 find_library(LIBSODIUM_SHARED sodium)
 find_library(LIBMBEDTLS_SHARED mbedtls)
@@ -97,13 +99,37 @@
 find_library(LIBUDNS_SHARED udns)
 find_library(LIBPCRE_SHARED pcre)
 
-list(APPEND DEPS bloom m ${LIBEV} ${LIBUDNS} ${LIBPCRE} ${LIBSODIUM} ${LIBMBEDTLS} ${LIBMBEDCRYPTO})
-list(APPEND DEPS_SHARED bloom-shared m ${LIBEV_SHARED} ${LIBUDNS_SHARED} ${LIBPCRE_SHARED} ${LIBSODIUM_SHARED}
-${LIBMBEDTLS_SHARED} ${LIBMBEDCRYPTO_SHARED})
+# Dependencies we need for static and shared
+if (WITH_STATIC)
+list(APPEND DEPS
+        m
+        bloom
+        ${LIBEV}
+        ${LIBUDNS}
+        ${LIBPCRE}
+        ${LIBSODIUM}
+        ${LIBMBEDTLS}
+        ${LIBMBEDCRYPTO}
+        )
+endif ()
+
+list(APPEND DEPS_SHARED
+        m
+        bloom-shared
+        ${LIBEV_SHARED}
+        ${LIBUDNS_SHARED}
+        ${LIBPCRE_SHARED}
+        ${LIBSODIUM_SHARED}
+        ${LIBMBEDTLS_SHARED}
+        ${LIBMBEDCRYPTO_SHARED}
+        )
 
 find_package (Threads)
 
-# Add our targets
+if (WITH_STATIC)
+# ------------------------------------------------------------------
+# Static
+# By default we use normal name for static, all shared targets will add a `-shared' suffix
 add_executable(ss-server ${SS_SERVER_SOURCE})
 add_executable(ss-tunnel ${SS_TUNNEL_SOURCE})
 add_executable(ss-manager ${SS_MANAGER_SOURCE})
@@ -129,9 +155,13 @@
 target_link_libraries(ss-local cork ipset ${DEPS})
 target_link_libraries(ss-redir cork ipset ${DEPS})
 target_link_libraries(shadowsocks-libev cork ipset ${DEPS})
+endif ()
 
 # ------------------------------------------------------------------
 # Shared
+# Shared target will have a `-shared' suffix
+# All shared dependency also have `-shared' suffix
+# For shared binary, we still use the same name as static, without `-shared', but will output to shared directory
 add_executable(ss-server-shared ${SS_SERVER_SOURCE})
 add_executable(ss-tunnel-shared ${SS_TUNNEL_SOURCE})
 add_executable(ss-manager-shared ${SS_MANAGER_SOURCE})
@@ -165,17 +195,28 @@
 
 set_target_properties(ss-server-shared ss-tunnel-shared ss-manager-shared ss-local-shared ss-redir-shared
         PROPERTIES
-        RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/shared/bin"
+        RUNTIME_OUTPUT_DIRECTORY ${RUNTIME_SHARED_OUTPUT_DIRECTORY}
         )
 
 set_target_properties(shadowsocks-libev-shared PROPERTIES OUTPUT_NAME shadowsocks-libev)
 target_compile_definitions(shadowsocks-libev-shared PUBLIC -DMODULE_LOCAL)
 target_link_libraries(shadowsocks-libev-shared cork-shared ipset-shared ${DEPS_SHARED})
 
-
-install(DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
-        DESTINATION bin
-        FILES_MATCHING PATTERN "ss-*")
+# ------------------------------------------------------------------
+# Misc
+# Recommend to install shared by default
+install(DIRECTORY ${RUNTIME_SHARED_OUTPUT_DIRECTORY}/
+        DESTINATION bin)
+
+if (WITH_STATIC)
+    install(TARGETS shadowsocks-libev
+        ARCHIVE DESTINATION lib)
+endif ()
+
+install(TARGETS shadowsocks-libev-shared
+        LIBRARY DESTINATION lib)
+
+install(FILES shadowsocks.h DESTINATION include)
 
 
 add_custom_target(distclean

=== debian/changelog ===
shadowsocks-libev (3.0.8+ds-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rogershimizu@gmail.com>  Tue, 08 Aug 2017 10:12:26 -0400

shadowsocks-libev (3.0.8+ds-2) unstable; urgency=medium

  * debian/patches:
    - Backport a patch from upstream to update json.c to latest,
      to fix a security issue.
    - Refresh patches.
  * debian/control:
    - Bump libsodium-dev required version to 1.0.12, to enable more ciphers.

 -- Roger Shimizu <rogershimizu@gmail.com>  Thu, 03 Aug 2017 01:37:26 +0900

shadowsocks-libev (3.0.8+ds-1) unstable; urgency=medium

  * New upstream release 3.0.8

 -- Roger Shimizu <rogershimizu@gmail.com>  Fri, 28 Jul 2017 00:38:39 +0900

shadowsocks-libev (3.0.7+ds-2~bpo8+1) jessie-backports-sloppy; urgency=medium

  * Rebuild for jessie-backports-sloppy.

 -- Roger Shimizu <rogershimizu@gmail.com>  Sat, 15 Jul 2017 22:49:12 +0900

shadowsocks-libev (3.0.7+ds-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rogershimizu@gmail.com>  Sat, 15 Jul 2017 20:49:07 +0900

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  libev-dev,
  libmbedtls-dev,
  libpcre3-dev,
- libsodium-dev (>= 1.0.8~),
+ libsodium-dev (>= 1.0.12),
  libudns-dev,
  pkg-config,
  xmlto

## shadowsocks-libev 3.1.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2017-7-27)
-set(PROJECT_VERSION "3.0.8")
+set(RELEASE_DATE 2017-9-15)
+set(PROJECT_VERSION "3.1.0")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")

=== debian/changelog ===
shadowsocks-libev (3.1.0+ds-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rogershimizu@gmail.com>  Sat, 14 Oct 2017 16:24:56 +0900

shadowsocks-libev (3.1.0+ds-1) unstable; urgency=medium

  * Release to unstable.
  * d/patches:
    - Backport a few patches from upstream.
      + [b721c0f] Update docs for TCP_NODELAY.
      + [82694c8] properly set recv_ctx->connected.
      + [da85fa1] Fix scripts/build_deb.sh for debian jessie.
      + [10a2d3e] Fix make distclean failure when
        ./configure --disable-documentation
  * Remove debian/source.lintian-overrides from
    debian/source.lintian-override, since it's unused.

 -- Roger Shimizu <rogershimizu@gmail.com>  Sat, 07 Oct 2017 01:36:58 +0900

shadowsocks-libev (3.1.0+ds-1~exp1) experimental; urgency=medium

  * New upstream release 3.1.0
  * d/control:
    - Note replacing dependency libudns-dev with libc-ares-dev.

 -- Roger Shimizu <rogershimizu@gmail.com>  Wed, 20 Sep 2017 01:38:40 +0900

shadowsocks-libev (3.0.8+ds-2~bpo8+1) jessie-backports-sloppy; urgency=medium

  * Rebuild for jessie-backports-sloppy.

 -- Roger Shimizu <rogershimizu@gmail.com>  Tue, 08 Aug 2017 15:14:25 -0400

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,13 @@
  asciidoc-base | asciidoc,
  debhelper (>= 10),
  libbloom-dev,
+ libc-ares-dev,
  libcork-dev (>= 0.15.0+ds-8),
  libcorkipset-dev,
  libev-dev,
  libmbedtls-dev,
  libpcre3-dev,
  libsodium-dev (>= 1.0.12),
- libudns-dev,
  pkg-config,
  xmlto
 Standards-Version: 4.0.0
